image: gitlab/dind

services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE
  SHARED_PATH: /builds/shared/$CI_PROJECT_PATH

stages:
  - build
  - deploy

build_image:
  stage: build
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - mkdir -p ${SHARED_PATH}
    - docker build --pull -t $CONTAINER_TEST_IMAGE:latest .
    - docker push $CONTAINER_TEST_IMAGE
  rules:
    - changes:
      - Dockerfile

pages:
  stage: deploy
  script:
  - Rscript -e "quarto::quarto_render('index.qmd', output_file = 'index.html')"
  - tree -a
  - mkdir public
  - cp -r docs/* public/
  artifacts:
    paths:
    - public
  only:
  - main
  interruptible: true
